#!/usr/bin/env python3
# Uses jisho.org API to get japanese word definitions

import sys
import json
import requests

def lookup(results, limit):
        count = 0
        if(len(results['data']) == 0):
                print("No results found.")
        for word in results['data']:
                if(count == limit):
                        break
                count +=1
                print(word['slug'], end=" (")
                # For some reason, Jisho API wraps the values of the key 'senses' & 'japanese' into an array of index 0
                print(word['japanese'][0]['reading']+"): ") # TODO: check that an actual 'reading' exists (some phrases dont have readings)
                for definition in word['senses'][0]['english_definitions']:
                        print(definition)
                print()
                
def main(args):
        word = args[0]
        api_base_url = 'https://jisho.org/api/v1/search/words?keyword='
        api_url = api_base_url+word
        req = requests.get(api_url)
        results = None
    
        # Check if jisho.org header sent valid data
        if req.status_code == 200:
                results = json.loads(req.content.decode('utf-8'))

                # find more progmatic way to implement args
                # probably use argpy
                if(len(args) == 2):
                        display_limit = int(args[1])
                        lookup(results, display_limit)
                else:
                        lookup(results, None)
        else:
                print("Failed to search. Jisho returned error status code " + req.status_code)

if __name__ == "__main__":
        main(sys.argv[1::]) 
        # find better modular method to handle arguments
        # Implement japanese flag so it uses a japanese EDICT for results

